package{
  import flash.display.Sprite;
  import flash.display.Stage;
  import flash.events.Event;
  import flash.events.KeyboardEvent;
  import flash.events.MouseEvent;
  import flash.text.TextFormat;
  import flash.ui.Keyboard;
  import component.Button;

//--------------------------------------------------------------------//
// ANVǗNX
  public class GlobeActionManager{

// gEk
    public static const RADIUS_COEF:Number=1.2;

// _oxω
    public static const THETA_X:Number=15.0;

// _ܓxω
    public static const THETA_Y:Number=10.0;

// Xe[W
    internal var stage:Stage;

// n}\f
    internal var view:GlobeViewModel;

// }EX{^Ă邩ǂ
    internal var pressed:Boolean;

// }EXʒu
    internal var mx:int;
    internal var my:int;

// \[hؑփ{^
    internal var mode:Button;

// sprite - eXvCg
// view - n}\f
// x,y,width - \ʒuAA
// textFormat - eLXg
    public function GlobeActionManager(sprite:Sprite,
      	      	      	      	       view:GlobeViewModel,
      	      	      	      	       x:int,y:int,width:int,
      	      	      	      	       textFormat:TextFormat){
      stage=sprite.stage;
      this.view=view;
      stage.addEventListener(MouseEvent.MOUSE_DOWN,mousePressed);
      stage.addEventListener(MouseEvent.MOUSE_UP,mouseReleased);
      stage.addEventListener(MouseEvent.MOUSE_MOVE,mouseMoved);
      stage.addEventListener(KeyboardEvent.KEY_DOWN,keyPressed);
      pressed=false;
      mx=0;
      my=0;
      addButtons(sprite,x,y,width,textFormat);
    }

//--------------------------------------------------------------------//
// {^ǉ
// sprite - eXvCg
// x,y,width - \ʒuA
// textFormat - eLXg
    internal function addButtons(sprite:Sprite,x:int,y:int,
      	      	      	      	 width:int,textFormat:TextFormat):void{
      var bgColor:uint=0xffffff;
      var fgColor:uint=0x000000;
      textFormat.color=fgColor;
      var w:int=width*3/10;
      var zoomin:Button=new Button("zoom in",fgColor,bgColor,
      	      	      	      	   x,y,textFormat);
      var zoomout:Button=new Button("zoom out",fgColor,bgColor,
      	      	      	      	    x+w,y,textFormat);
      mode=new Button("Globe",fgColor,bgColor,x+2*w,y,textFormat);

      zoomin.addEventListener(MouseEvent.CLICK,zoomIn);
      zoomout.addEventListener(MouseEvent.CLICK,zoomOut);
      mode.addEventListener(MouseEvent.CLICK,changeMode);

      sprite.addChild(zoomin);
      sprite.addChild(zoomout);
      sprite.addChild(mode);
    }

//--------------------------------------------------------------------//
// }EX{^̏s
    internal function mousePressed(event:MouseEvent):void{
      pressed=true;
      mx=stage.mouseX;
      my=stage.mouseY;
      view.setPointer(mx,my);
      view.draw();
    }

//--------------------------------------------------------------------//
// }EX{^𗣂̏s
    internal function mouseReleased(event:MouseEvent):void{
      pressed=false;
    }

//--------------------------------------------------------------------//
// }EX{^ړ̏s
    internal function mouseMoved(event:MouseEvent):void{
      if(pressed){
      	view.rotate(mx-stage.mouseX,stage.mouseY-my);
      	mx=stage.mouseX;
      	my=stage.mouseY;
      	view.draw();
      }
    }

//--------------------------------------------------------------------//
//L[̏s
    internal function keyPressed(event:KeyboardEvent):void{
      switch(event.keyCode){
      	case Keyboard.NUMPAD_4:
      	case Keyboard.LEFT:
      	  view.rotate(THETA_X,0);
      	  view.draw();
      	  break;
      	case Keyboard.NUMPAD_6:
      	case Keyboard.RIGHT:
      	  view.rotate(-THETA_X,0);
      	  view.draw();
      	  break;
      	case Keyboard.NUMPAD_2:
      	case Keyboard.DOWN:
      	  view.rotate(0,THETA_Y);
      	  view.draw();
      	  break;
      	case Keyboard.NUMPAD_8:
      	case Keyboard.UP:
      	  view.rotate(0,-THETA_Y);
      	  view.draw();
      	  break;
      	case Keyboard.NUMPAD_1:
      	case Keyboard.NUMBER_1:
      	case Keyboard.NUMPAD_ADD:
      	case Keyboard.SEMICOLON:
      	  view.zoom(RADIUS_COEF);
      	  break;
      	case Keyboard.NUMPAD_0:
      	case Keyboard.NUMBER_0:
      	case Keyboard.NUMPAD_SUBTRACT:
      	case Keyboard.MINUS:
      	  view.zoom(1.0/RADIUS_COEF);
      	  break;
      }
    }

//--------------------------------------------------------------------//
// g傷
    internal function zoomIn(event:Event):void{
      view.zoom(RADIUS_COEF);
    }

//--------------------------------------------------------------------//
// k
    internal function zoomOut(event:Event):void{
      view.zoom(1.0/RADIUS_COEF);
    }

//--------------------------------------------------------------------//
// \[h؂ւ
    internal function changeMode(event:Event):void{
      switch(view.viewMode){
      	case GlobeViewModel.GLOBE:
      	  view.viewMode=GlobeViewModel.ECP;
      	  mode.setLabel("ECP");
      	  view.draw();
      	  break;
      	case GlobeViewModel.ECP:
      	  view.viewMode=GlobeViewModel.GLOBE;
      	  mode.setLabel("Globe");
      	  view.draw();
      	  break;
      }
    }
  }
}
