package{
  import flash.display.Graphics;
  import flash.display.Sprite;
  import flash.text.TextFormat;
  import component.ViewModel;
  import figure.SphericalAngle;

//--------------------------------------------------------------------//
// n}\f
  public class GlobeViewModel extends ViewModel{

// nV[h\
    public static const GLOBE:int=0;

// ~}@[h\
    public static const ECP:int=1;

// pxWAɕϊW
    public static const TO_RADIAN:Number=Math.PI/180.0;

// Cݐf[^f
    internal var mapModel:GlobeMapModel;

// ssf[^f
    internal var cityModel:GlobeCityModel;

// ss|C^
    internal var pointer:GlobeCityPointer;

// _px
    internal var sa:SphericalAngle;

// _px
    internal var thetaX:Number;

// _oxړx (nV[h)
    internal var coefX1:Number;

// _oxړx (~}@[h)
    internal var coefX2:Number;

// _ܓxړx
    internal var coefY:Number;

// nVa
    internal var radius:int;

// nVa̍ől
    internal var radiusMax:int;

// nVa̍ŏl
    internal var radiusMin:int;

// \[h
    public var viewMode:int;

// wiF
    internal var bgColor:uint;

// OiF
    internal var fgColor:uint;

// s\F
    internal var capitalColor:uint;

// ss\F
    internal var cityColor:uint;

// sprite - eXvCg
// model - znf[^f
// graphics - `OtBbNX
// x,y,width,height - \ʒuAA
// textFormat - eLXg
    public function GlobeViewModel(sprite:Sprite,mapModel:GlobeMapModel,
      	      	      	      	   cityModel:GlobeCityModel,
      	      	      	      	   graphics:Graphics,x:int,y:int,
      	      	      	      	   width:int,height:int,
      	      	      	      	   bgColor:uint,fgColor:uint,
      	      	      	      	   capitalColor:uint,cityColor:uint,
      	      	      	      	   textFormat:TextFormat){
      super(graphics,x,y,width,height);
      this.mapModel=mapModel;
      this.cityModel=cityModel;
      sa=new SphericalAngle();
      sa.set(Math.PI*135.0/180.0,0.0);
      thetaX=135.0;
      pointer=new GlobeCityPointer(textFormat);
      viewMode=GLOBE;
      setPaint();

      this.bgColor=bgColor;
      this.fgColor=fgColor;
      this.capitalColor=capitalColor;
      this.cityColor=cityColor;

      sprite.addChild(pointer);
    }

//--------------------------------------------------------------------//
// ss|C^ݒ肷
// x,y - }EXʒu
    public function setPointer(x:int,y:int):void{
      pointer.setPointer(cityModel.click(x,y));
    }

//--------------------------------------------------------------------//
// gEk
// coef - ågEkW
    public function zoom(coef:Number):void{
      if(viewMode==GLOBE){
      	radius=Math.max(Math.min(int(coef*radius),radiusMax),radiusMin);
      	draw();
      }
    }

//--------------------------------------------------------------------//
// _ʒu]
    public function rotate(dx:Number,dy:Number):void{
      switch(viewMode){
      	case GLOBE:
      	  rotateMap(coefX1*dx,coefY*dy);
      	  break;
      	case ECP:
      	  rotateMap(coefX2*dx,0.0);
      	  break;
      }
    }

//--------------------------------------------------------------------//
// _ʒu]
    internal function rotateMap(dx:Number,dy:Number):void{
      thetaX+=dx;
      if(thetaX>180.0)       thetaX-=360.0;
      else if(thetaX<-180.0) thetaX+=360.0;
      sa.rotate(TO_RADIAN*dx,TO_RADIAN*dy);
    }

//--------------------------------------------------------------------//
// `ݒ肷
    internal function setPaint():void{
      coefX1=144.0/region.width;
      coefY=144.0/region.height;
      coefX2=360.0/region.width;
      radius=int(0.8*Math.min(cx,cy));
      radiusMax=10*radius;
      radiusMin=radius;
    }

//--------------------------------------------------------------------//
// `悷
    public function draw():void{
      drawInit(bgColor);

      mapModel.draw(graphics,viewMode,sa,thetaX,cx,cy,radius,fgColor);
      cityModel.draw(graphics,viewMode,sa,thetaX,cx,cy,radius,
      	      	     capitalColor,cityColor);
      switch(pointer.type){
      	case GlobeCityPointer.CAPITAL:
      	  pointer.setView(region,capitalColor);
      	  break;
      	case GlobeCityPointer.CITY:
      	  pointer.setView(region,cityColor);
      	  break;
      }
    }
  }
}
